#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Sbaeder, whith a lot of help and inspiration from the net and other wbzip scripting

 Script Function:
	A GUI for the uWBZip functionality.  i.e. Two tabbed interfaces 
	
	One to Extract files from a script container, which uses concept of unwbzip.cmd script
	to "search" the script for the header indicators of the compressed files, put that into a list
	and allow you to select which files you want. 

		By default, it creates folders based on the script, and sub-folders for any files that need to be in folders.

	The second tab is for adding files to a script, and it uses the folder names (or if it finds a plain file 
	in the specified location, adds  it into the default name of "folder". It puts the name into the list view 
	items so you can see what it has done.  ( a lot simpler that the original GUI of Pedrole.
	
Note: A lot of the code was inspired bu a script that reads CD contents and allows you to "rip" them using Lame encoder

#ce ----------------------------------------------------------------------------


#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <StaticConstants.au3>
#include <WinAPI.au3>
#include <GuiListView.au3>
#include <file.au3>
#include <String.au3>
#include <Array.au3>
#Include <GuiButton.au3>

Global $hGui, $iScriptFile, $iOutput, $iBrowse_out, $iBrowse, $iLV, $iInv, $iRip, $iAll
Global $aItemRow, $iFlag = 0, $iFormat = 1, $Button_Exit

Global $sOutPath = "<Select Output Folder>"
Global $sInFolder = "<Select Input Folder>"
Global $sInPath = "<Select Source Script File>"
Global $sOutScript = "<Select Output Script File>" 
Global $sFmt = "%-8s|%-s"

$hGui = GUICreate("GUI for WBZip", 385, 510)

$hTab = GUICtrlCreateTab(10, 10, 365, 489)

GUICtrlCreateTabItem("Extract files from script " )

GUICtrlCreateGroup("Select Script:", 15, 35, 345, 55)
$iScriptFile = GUICtrlCreateInput($sInPath, 25, 55, 300, 20, BitOR($ES_READONLY, $ES_AUTOHSCROLL))
GUICtrlSetBkColor(-1, 0xffffff)
$iBrowse = GUICtrlCreateButton("...", 330, 55, 20, 20)
GUICtrlSetTip(-1, "Browse for script file.")

GUICtrlCreateGroup("Save To...", 15, 95, 345, 55)
$iOutput = GUICtrlCreateInput($sOutPath, 25, 115, 300, 20, BitOR($ES_READONLY, $ES_AUTOHSCROLL))
GUICtrlSetBkColor(-1, 0xffffff)
$iBrowse_out = GUICtrlCreateButton("...", 330, 115, 20, 20)
GUICtrlSetTip(-1, "Browse for save directory.")

GUICtrlCreateGroup("Content Selection:", 15, 155, 345, 275)
$iLV = GUICtrlCreateListView("File Name|Section (Folder)", 25, 175, 325, 250, -1, BitOR($LVS_EX_CHECKBOXES, $LVS_EX_FULLROWSELECT))

$iInv = GUICtrlCreateButton("Invert Selected", 25, 435, 160, 20)
$iAll = GUICtrlCreateButton("Select All", 190, 435, 160, 20)

$iRip = GUICtrlCreateButton("Extract Files", 25, 460, 160, 30, $BS_MULTILINE)
GUICtrlSetFont(-1,10,700,0,"Arial")

$Button_Exit = GuiCtrlCreateButton("Exit", 190, 460, 160, 30)
GUICtrlSetFont(-1,10,700,0,"Arial")

;-----------------------------------------------------Encode Tab
GUICtrlCreateTabItem("Add Folder to script " )

GUICtrlCreateGroup("Source Folder...", 15, 35, 345, 55)
$iFolder = GUICtrlCreateInput($sInFolder, 25, 55, 300, 20, BitOR($ES_READONLY, $ES_AUTOHSCROLL))
GUICtrlSetBkColor(-1, 0xffffff)
$iBrowse_in = GUICtrlCreateButton("...", 330, 55, 20, 20)
GUICtrlSetTip(-1, "Browse for source file directory.")

GUICtrlCreateGroup("Select Script:", 15, 95, 345, 55)
$iScriptFile_encode = GUICtrlCreateInput($sOutScript, 25, 115, 300, 20, BitOR($ES_READONLY, $ES_AUTOHSCROLL))
GUICtrlSetBkColor(-1, 0xffffff)
$iBrowse_encode = GUICtrlCreateButton("...", 330, 115, 20, 20)
GUICtrlSetTip(-1, "Browse for script file.")

GUICtrlCreateGroup("Files Processed:", 15, 155, 345, 295)
$iLV2 = GUICtrlCreateListView("File Name|Section (Folder)", 25, 175, 325, 265, -1, BitOR($LVS_EX_CHECKBOXES, $LVS_EX_FULLROWSELECT))

$iAdd = GUICtrlCreateButton("Add Folder", 25, 460, 160, 30, $BS_MULTILINE)
GUICtrlSetFont(-1,10,700,0,"Arial")

$Button_Exit2 = GuiCtrlCreateButton("Exit", 190, 460, 160, 30)
GUICtrlSetFont(-1,10,700,0,"Arial")

GUISetState(@SW_SHOW, $hGui)
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")

; This is the current active tab
$iLastTab = 0

;Before we start teh GUI loop, extract the executable that does the work
$WBzip = @TempDir & "\WBzip.exe"
FileInstall("D:\WB\TOOLS\wbzip\WBzip.exe", $WBzip)

While 1
    Switch GUIGetMsg()
        Case $GUI_EVENT_CLOSE
            Exit
        Case $iBrowse
            _Browse()
        Case $iBrowse_out
            _Browse_Out()
		Case $iBrowse_in
            _Browse_In()
		Case $iBrowse_encode
            _Browse_encode()
        Case $iInv
            For $i = 0 To _GUICtrlListView_GetItemCount($iLV) - 1
                If _GUICtrlListView_GetItemChecked($iLV, $i) Then
                    _GUICtrlListView_SetItemChecked($iLV, $i, False)
                Else
                    _GUICtrlListView_SetItemChecked($iLV, $i)
                EndIf
            Next
            $iFlag = 1
        Case $iAll
            For $i = 0 To _GUICtrlListView_GetItemCount($iLV) - 1
                If Not _GUICtrlListView_GetItemChecked($iLV, $i) Then _GUICtrlListView_SetItemChecked($iLV, $i)
            Next
            $iFlag = 1
        Case $iRip
            Extract_Files()
		Case $iAdd
			Add_Files()
		Case $Button_Exit
			ExitLoop
		Case $Button_Exit2
			ExitLoop
		Case $hTab
            ; Check which Tab is active
            $iCurrTab = GUICtrlRead($hTab)
            ; If the Tab has changed
            If $iCurrTab <> $iLastTab Then
                ; Show/Hide controls as required
                Switch $iCurrTab
                    Case 0
                        ;just came back to tab 0, so reload (if possible) the list of files
						_LoadFilesToLV()
                    Case 1
                        ; Just switched to tab 1
						 _GUICtrlListView_DeleteAllItems($iLV2)
                EndSwitch
                ; Store the value for future comparisons
                $iLastTab = $iCurrTab
            EndIf
		Case Else
            ;
    EndSwitch
WEnd
If  FileExists($WBzip) Then FileDelete($WBzip)

;========================================================================================
;=========== End Main GUI Loop ==========================================================


Func Extract_Files()
    Local $sDrv, $aDrv, $iOverwrite, $hCD, $tINF, $tWavHdr, $tWavBuf, $tMP3Buf, $tCfg
    Local $sCurTrack, $hWriteOut, $hStream, $iReturn, $iSamples, $iMP3Buffer, $iOutput, $iWritten
    Local $iTS = 0, $iTSS = 0, $iTSD = 0, $aTCL[2], $iTP = 0, $iTPD = 0, $aPCL[2], $iStep = 28 ;$iStep = 288
	Local $aItem, $ii, $sText
 
	GUICtrlSetState($iRip, $GUI_DISABLE)
	
	For $i = 1 To _GUICtrlListView_GetItemCount($iLV)
        If _GUICtrlListView_GetItemChecked($iLV, $i - 1) Then
			; [1] is file name, and [2] is section
			$aItem = _GUICtrlListView_GetItemTextArray($iLV, $i - 1)
            If FileExists($sOutPath & StringFormat("\%s\%s", $aItem[2], $aItem[1])) Then $iOverwrite = 1
        EndIf
    Next
    If $iOverwrite Then
        Switch MsgBox(512+38, 'Overwite Warning', 'You are about to overwrite already existing files.' & @LF & _
                'Would you like to CONTINUE?' & @LF & @LF & _
                'Click "Continue" to Overwrite existing files.' & @LF & _
                'Click "Try Again" to browse for a different save directory.' & @LF & _
                'Click "Cancel" to Abort extracting files.')
            Case 2
                Return
            Case 10
                _Browse_Out()
        EndSwitch
    EndIf
    If Not FileExists($sOutPath) Then DirCreate($sOutPath)
    
    ; Loop through the list view, if the file is selected then process it.
    For $i = 1 To _GUICtrlListView_GetItemCount($iLV)
        If _GUICtrlListView_GetItemChecked($iLV, $i - 1) Then
			$aItem = _GUICtrlListView_GetItemTextArray($iLV, $i - 1)
			For $ii = 1 To $aItem[0]
				$sText &= StringFormat("Column[%2d] %s", $ii, $aItem[$ii]) & @LF
			Next
			;;MsgBox(4160, "Information", "Item (All Columns) Text: " & @LF & @LF & $sText)
			$sText = ""
			If Not FileExists($sOutPath & "\" & $aItem[2]) Then DirCreate($sOutPath & "\" & $aItem[2])
			;;MsgBox(0,"unzip command",'"' & $WBzip & '" -x "' & $sInPath & '" "' & $aItem[2] & '" "' & $aItem[1] & '" "' & $sOutPath &  $aItem[2] & '"')
			RunWait('"' & $WBzip & '" -x "' & $sInPath & '" "' & $aItem[2] & '" "' & $aItem[1] & '" "' & $sOutPath & $aItem[2] & '"',"",@SW_HIDE)
			_GUICtrlListView_SetItemChecked($iLV, $i - 1, False)
		EndIf
    Next
    GUICtrlSetState($iRip, $GUI_ENABLE)
	MsgBox(0,"Task Completed","Extracted selected folders and files from script")
	Return 
EndFunc   ;==>Extract_Files



Func _LoadFilesToLV()
    Local $file1, $value1, $line, $err_sav, $sDrv, $aDrv 
	Local $Name, $Section, $iTrkSector, $iTrkMS
    
    _GUICtrlListView_DeleteAllItems($iLV)
    
	$file1 = FileOpen($sInPath, 0)
	If $file1 = -1 Then Return

	; Read in lines of text until the EOF is reached
	While 1
		$line = FileReadLine($file1)
		If @error = -1 Then ExitLoop
		$line = String($line)
		;MsgBox(0,"","Line: " & $line)
		If StringInStr ( $line, "[EncodedFile-", 0, 1, 1, 20 ) Then
			$value1 = _StringBetween($line, '[', ']') 
			$Section = _StringBetween($Value1[0], "-", "-")
			If StringInStr($value1[0], "-",0,2) > 0 Then 
				$Name = StringTrimLeft($value1[0],StringInStr($value1[0], "-",0,2))
				;MsgBox(0,"",$Name)
			EndIf
			GUICtrlCreateListViewItem(StringFormat($sFmt, $Name, $Section[0]), $iLV)
			GUICtrlSetState(-1, $GUI_CHECKED)
		EndIf
	WEnd
	FileClose($file1)
	; resize fields to fit
	_GUICtrlListView_SetColumnWidth($iLV, 0, $LVSCW_AUTOSIZE)
    _GUICtrlListView_SetColumnWidth($iLV, 1, $LVSCW_AUTOSIZE_USEHEADER) 
	
	GUICtrlSetState($iInv, $GUI_ENABLE)
    GUICtrlSetState($iAll, $GUI_ENABLE)
    
	$iFlag = 1
EndFunc   ;==>_LoadFilesToLV


Func Add_Files()
	GUICtrlSetState($iAdd, $GUI_DISABLE)
	If Not FileExists($sOutScript) Then
		Switch MsgBox(512+38, 'Warning', 'Output Script file does not already exist.' & @LF & _
                'Would you like to CONTINUE?' & @LF & @LF & _
                'Click "Continue" to create new script file.' & @LF & _
                'Click "Try Again" to browse for a different script file.' & @LF & _
                'Click "Cancel" to Abort encoding selected folder.')
            Case 2
                Return
            Case 10
                _Browse_encode()
			EndSwitch
		$error = FileOpen($sOutScript, 2 )
		If $error = -1 Then
			MsgBox(0, "Error", "Unable to open file.")
			GUICtrlSetState($iAdd, $GUI_ENABLE)
			Return
		EndIf
	EndIf
	
	If Not FileExists($sInFolder) Then
		Switch MsgBox(512+37, 'Warning', 'Input Folder does not exist.' & @LF & _
                'Would you like to CONTINUE?' & @LF & @LF & _
                'Click "Retry" to locate a new file folder.' & @LF & _
                'Click "Cancel" to Abort encoding selected folder.')
            Case 4
                _Browse_In()
			EndSwitch
			GUICtrlSetState($iAdd, $GUI_ENABLE)
		Return
	EndIf
		
	; We assume any file at this level goes into the "default" group called "folder" even if we find a "folder
	; directory.  Any other directory, is a folder to parse for additional files.
	$i = 0
	$search = FileFindFirstFile($sInFolder & "\*.*")
    While 1
        Dim $file = FileFindNextFile($search)
        If @error Or StringLen($file) < 1 Then ExitLoop
        If StringInStr(FileGetAttrib($sInFolder & "\" & $file), "D") And ($file <> "." Or $file <> "..") Then
			;Found a directory
			$search2 = FileFindFirstFile($sInFolder & "\" & $file & "\*.*")
			While 1
				Dim $file2 = FileFindNextFile($search2)
				If @error Or StringLen($file) < 1 Then ExitLoop
				If Not StringInStr(FileGetAttrib($sInFolder & "\" & $file & "\" & $file2), "D") Then
					GUICtrlCreateListViewItem(StringFormat($sFmt, $file2, $file), $iLV2)
					; resize fields to fit
					_GUICtrlListView_SetColumnWidth($iLV2, 0, $LVSCW_AUTOSIZE)
					_GUICtrlListView_SetColumnWidth($iLV2, 1, $LVSCW_AUTOSIZE_USEHEADER)
					_GUICtrlListView_SetItemChecked($iLV2, $i, False)					
					RunWait('"' & $WBzip & '" -a "' & $sOutScript & '" "' & $file & '" "' & $sInFolder & "\" & $file & "\" & $file2 & '"',"",@SW_HIDE)
					;MsgBox(0,"",'"' & $WBzip & '" -a "' & $sOutScript & '" "' & $file & '" "' & $sInFolder & "\" & $file & "\" & $file2 & '"')
					_GUICtrlListView_SetItemChecked($iLV2, $i)
					$i = $i + 1
				EndIf
			WEnd
			FileClose($search2)
		Else
			;found a File, so process it
			GUICtrlCreateListViewItem(StringFormat($sFmt, $file, "Folder"), $iLV2)
			; resize fields to fit
			_GUICtrlListView_SetColumnWidth($iLV2, 0, $LVSCW_AUTOSIZE)
			_GUICtrlListView_SetColumnWidth($iLV2, 1, $LVSCW_AUTOSIZE_USEHEADER)
			_GUICtrlListView_SetItemChecked($iLV2, $i, False)
			RunWait('"' & $WBzip & '" -a "' & $sOutScript & '" "' & "Folder" & '" "' & $file & '"',"",@SW_HIDE)
			;MsgBox(0,"",'"' & $WBzip & '" -a "' & $sOutScript & '" "' & "Folder" & '" "' & $file & '"')
			_GUICtrlListView_SetItemChecked($iLV2, $i)
			$i = $i + 1
        EndIf
    WEnd
	MsgBox(0,"Task Completed","Added selected folders and files to script")
	GUICtrlSetState($iAdd, $GUI_ENABLE)
	Return 
EndFunc


Func _Browse()
    Local $sFSF, $szDrive, $szDir, $szFName, $szExt, $TestPath
    $sFSF = FileOpenDialog("Select the script file:", @ScriptDir, "Script Files (*.script)|All (*.*)" )
    If Not @error Then
        $sInPath = $sFSF
        GUICtrlSetData($iScriptFile, $sInPath)
		_LoadFilesToLV()
    EndIf
	; Set default output folder as well
	If FileExists($sInPath) Then 
		$TestPath = _PathSplit($sInPath, $szDrive, $szDir, $szFName, $szExt)
		$sOutPath = $szDrive & $szDir & $szFName & "\"
		GUICtrlSetData($iOutput, $sOutPath)
	EndIf
EndFunc   ;==>_Browse

Func _Browse_Out()
    Local $sFSF
	$sFSF = FileSelectFolder("Select a folder to save extracted files in.", "", 7, $sOutPath, $hGui)
    If Not @error Then
        $sOutPath = $sFSF & "\"
        GUICtrlSetData($iOutput, $sOutPath )
    EndIf
EndFunc   ;==>_Browse_Out

Func _Browse_In()
    Local $sFSF
	$sFSF = FileSelectFolder("Select a folder with files to encode.", "", 7, @ScriptDir, $hGui)
    If Not @error Then
        $sInFolder = $sFSF
        GUICtrlSetData($iFolder, $sInFolder)
    EndIf
EndFunc   ;==>_Browse_In

Func _Browse_encode()
    Local $sFSF
	$sFSF = FileOpenDialog("Select the script file:", @ScriptDir, "Script Files (*.script)|All (*.*)" )
    If Not @error Then
        $sOutScript = $sFSF
        GUICtrlSetData($iScriptFile_encode, $sOutScript)
    EndIf
EndFunc   ;==>_Browse_encode

Func WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
    #forceref $hWnd, $iMsg, $iwParam
    Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $hListView, $aHit
    $hListView = GUICtrlGetHandle($iLV)
    $tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
    $hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
    $iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
    $iCode = DllStructGetData($tNMHDR, "Code")
    Switch $hWndFrom
        Case $hListView
            Switch $iCode
                Case $NM_CLICK
                    $aHit = _GUICtrlListView_HitTest($hListView)
                    If $aHit[4] Then $iFlag = 1
            EndSwitch
    EndSwitch
    Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_NOTIFY

