program wbzip;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Classes,
  windows,
  Inifiles,
  SZCodeBaseX,
  ZLIBArchive2,
  StrUtils;


function GetTempDir: string;
var
  Buffer: array[0..255] of Char;
begin
  GetTempPath(SizeOf(Buffer) - 1, Buffer);
  Result := StrPas(Buffer);
end;  



Function Internal_ExtractFileToDisk(ScriptFile,InternalGroup,EncodedFile,PathToExtract:String):Boolean;
         var s,u : String;
             i   : Integer;

         var
          sIn,sOut : TFileStream;
          fIn,fOut : String;
          iIni     : TmemIniFile;
          ZFile    : TZLBArc2;
          memo3    : TStringList;

      begin

       Internal_ExtractFileToDisk := False;

        s:=ScriptFile;

        zFile := TZlbArc2.create(nil);
        memo3 := TStringList.Create;

        if(not FileExists(scriptFile))
        or(not DirectoryExists(PathToExtract))
        then exit;

       iIni:= TMemIniFile.Create(s);
       u := 'EncodedFile-'+InternalGroup+'-'+EncodedFile;
       if not iIni.SectionExists(u)then
                                begin
                                   result:=False;
                                   exit;
                                end;

       for i:=0 to iIni.ReadInteger(u,'lines',0)
        do
        Memo3.Add(iIni.ReadString(u,IntToStr(i),'') );
       fOut:= GetTempDir+ChangeFileExt(EncodedFile,'.arc');
       fIn := ChangeFileExt(fOut,'.b64');
       if(FileExists(fIn)) then deleteFile(PChar(fIn));
       if(FileExists(fOut))then deleteFile(PChar(fOut));
       memo3.SaveToFile(fIn);

  // Stream to stream
  sIn :=TFileStream.Create(fIn, fmOpenRead or fmShareDenyNone);
  sOut:=TFileStream.Create(fOut,fmCreate);

  // Full Base64 decoding - with padding keys
  SZDecodeBase64(sIn, sOut);

  sIn.Free;
  sOut.Free;

  DeleteFile(Pchar(fIn));
  iIni.Free;

  Zfile.OpenArchive(fOut);
  Zfile.ExtractAll(PathToExtract);
  ZFile.CloseArchive;
  DeleteFile(Pchar(fOut));

  memo3.Free;
  zfile.Free;

 EncodedFile := AnsiReplaceText(PathToExtract+'\'+EncodedFile,'\\','\');

  Internal_ExtractFileToDisk := FileExists(EncodedFile);

      end;





Function Internal_FileEncode(SourceFile, ScriptFile, InternalGroup : String):Boolean;

         var t,u,
             EncodedFile,
             TempFile
              : String;

         var
          sIn,sOut: TFileStream;
          fIn,fOut: String;

          iIni: TmemIniFile;

          i : integer;

          ZFile    : TZLBArc2;
          memo1    : TStringList;


      begin

       Internal_FileEncode:=False;

        if(not fileExists(ScriptFile))then exit;
        if(not fileExists(SourceFile))then exit;
              


        zFile := TZlbArc2.create(nil);
        memo1 := TStringList.Create;

       iIni:= TMemIniFile.Create(ScriptFile);

         EncodedFile := extractfilename(SourceFile);

         TempFile:=EncodedFile;



     fIn := GetTempDir+ ChangeFileExt(TempFile,'.arc');

     if(FileExists(fIn))then DeleteFile(PChar(fIn));


     Zfile.CreateArchive(fIn);
     Zfile.AddFile(SourceFile);
     zFile.CloseArchive;


     fOut :=  GetTempDir+ ChangeFileExt(TempFile,'.b64');

  if(FileExists(fOut))then DeleteFile(PChar(fOut));

  // Stream to stream
  sIn :=TFileStream.Create(fIn, fmOpenRead or fmShareDenyNone);
  sOut:=TFileStream.Create(fOut, fmCreate);

  SZEncodeBase64(sIn, sOut, -1, 4090);

  t:=IntToStr(sIn.Size)+','+IntToStr(sOut.Size);



  sIn.Free;
  sOut.Free;

  memo1.LoadFromFile(fOut);

    u:='EncodedFile-'+InternalGroup+'-'+EncodedFile;
    while iIni.SectionExists(u) do
          begin
            iIni.EraseSection(u);
          end;

            iIni.UpdateFile;

       iIni.WriteString(u,'lines','0');



   for i:=0 to memo1.Count-1
     do iIni.WriteString(u,IntToStr(i),memo1[i]);

   iIni.WriteString(u,'lines',IntToSTr(i-1));

   iIni.WriteString(InternalGroup,EncodedFile,t);


   DeleteFile(PChar(fOut));
{---------------------}
       memo1.Clear;
       iIni.UpdateFile;
       iIni.Free;

       zFile.Free;
       memo1.Free;

       Internal_FileEncode := True;
end;



var

 s : String;
 i : Integer;

begin
 if paramcount=0 then begin
     writeln('');
     writeln('WBzip - Encode and decode binary files on .script files');
     writeln('');
     writeln('    -x  Extract files from script');
     writeln('    -a  Add files to script');
     writeln('');
     writeln('Syntax:');
     writeln('');
     writeln('  wbzip.exe -x ScriptFile Section File OutputPath');
     writeln('  wbzip.exe -a ScriptFile Section File(s)');
     writeln('');
     writeln('version 1.0  [2006]');
     writeln('');
     writeln('< press any key to continue.. >');
     ReadLn(s);
     exit;
                   end;

  //wbzip -a script section file
  //wbzip -x script section file OutputPath


  s:= AnsiLowerCase(ParamStr(1));


  if s='-x' then begin
             if Internal_ExtractFileToDisk(ParamStr(2),paramstr(3),paramstr(4),paramstr(5))
             then s := 'Sucessfully extracted from script: ['+ParamStr(2)+'] section: ['+ParamStr(3)+'] file: ['+ParamStr(4)+'] To path: ['+ParamStr(5)+']'
             else s := 'Failed to extract from script: ['+ParamStr(2)+'] section: ['+ParamStr(3)+'] file: ['+ParamStr(4)+'] To path: ['+ParamStr(5)+']';
                writeln(s);
                 end;

//Encode(SourceFile, ScriptFile, InternalGroup : String):Boolean;
  //wbzip -a script section file
  //       1    2      3      4

  if s='-a' then begin
             if Internal_FileEncode(paramstr(4),ParamStr(2),paramstr(3))
             then s := 'Sucessfully encoded on file: ['+ParamStr(2)+'] section: ['+ParamStr(3)+'] file: ['+ParamStr(4)+']'
             else s := 'Failed to encode on file: ['+ParamStr(2)+'] section: ['+ParamStr(3)+'] file: ['+ParamStr(4)+']';
                writeln(s);
                 end;

end.
